// ====================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Qiang Huang
// Contributors: None
// Date:         2003-04-14
// Purpose:      Soft CAN User API
// Description:	 Those are the *only* API functions should be used by user application
//
//####DESCRIPTIONEND####
// ====================================================================

#ifndef CAN_API_H
#define CAN_API_H


#include <cyg/io/can_lib.h>
#include <cyg/io/can_drv.h>
#include <cyg/io/can_node.hxx>
#include <cyg/io/def.h>

extern unsigned char can_controller_name[];

// API functions used to send and receive a CAN message
// send out a CAN message
cyg_uint8 api_can_send(CANMsgStr can_str_msg);
cyg_uint8 api_can_send_block(CANMsgStr *can_str_msg);

// receive a CAN message, if no message is avaliable the "EMPTY" flag is returned, otherwise 
// "NOTEMPTY" flag is returned with the received CAN message
// mode = "MODE_REMOVE", remove the message from the system buffer
// mode = "MODE_NOREMOVE", leave the message in the system buffer
cyg_uint8 api_can_recv(CANMsgStr *pcan_str_msg, cyg_uint8 mode);
cyg_uint8 api_can_recv_block(CANMsgStr *pcan_str_msg, cyg_uint8 mode);
cyg_uint8 api_can_recv_higest_prio(CANMsgStr *pcan_str_msg, cyg_uint8 mode);



// Configuration API functions
// user api function used to set the speed of the CAN controller
cyg_uint8 api_can_set_speed(cyg_uint8 speed);

// set the acceptance mask and filter
cyg_uint8 api_can_set_mask_filter(cyg_uint16 can_mask, cyg_uint16 can_filter);

// set the can speed
cyg_uint8 cyg_api_can_set_speed(cyg_uint8 speed);
// set the can mask filter
cyg_uint8 cyg_api_can_set_mask_filter(cyg_uint16 can_mask, cyg_uint16 can_filter);
// get the can control setting
cyg_uint8 cyg_api_can_get_config(cyg_uint8 buf[]);


#endif	// CAN_API_H
