#ifndef CAN_DRV_H
#define CAN_DRV_H

#include <cyg/io/can_api.h>
#include <cyg/io/pld_config.h>
#include <cyg/kernel/kapi.h>
#include <cyg/io/can_node.hxx>

typedef struct can_channel {

	cyg_uint32 interrupt;
	cyg_uint16 mask;
	cyg_uint16 filter;
	cyg_uint8 speed;

}soft_can_channel;


// PIO Registers
typedef volatile struct
{
	cyg_uint32 np_piodata;          // read/write, up to 32 bits
	cyg_uint32 np_piodirection;     // write/readable, up to 32 bits, 1->output bit
	cyg_uint32 np_piointerruptmask; // write/readable, up to 32 bits, 1->enable interrupt
	cyg_uint32 np_pioedgecapture;   // read, up to 32 bits, cleared by any write
} np_pio;

#define na_can_pio	( (np_pio *)0x80000100 ) // altera_avalon_pio
#define can_reset_pio	( (np_pio *)0x80000120 ) // altera_avalon_pio
#define na_led_pio	( (np_pio *)0x80000110 ) // altera_avalon_pio

#endif // CAN_DRV_H
