#ifndef CAN_NODE_HXX
#define	CAN_NODE_HXX

#include <cyg/io/def.h>

#ifdef __cplusplus

#include <pkgconf/system.h>
#include <pkgconf/memalloc.h>
#include <cyg/io/can_lib.h>
#include <cyg/infra/clist.hxx>

// Node Class with specified type to Cyg_CANMSG_NODE
class Cyg_CANMSG_NODE : public Cyg_DNode_T<Cyg_CANMSG_NODE>
{

public:
	Cyg_CANMSG_NODE()
	{
		std_id = 0;
		ext_id = 0;
		length = 0;
		can_block_mode = CAN_NOBLOCK;
	};

	~Cyg_CANMSG_NODE(){ };

	// variable for storing standard CAN ID
	unsigned int	std_id;
	
	// variable for storing extended CAN ID
	unsigned int	ext_id;

	// variable for storing the length of the CAN message
	unsigned char	length;

	// variable for storing the CAN message data
	unsigned char	data[8];

	// can block mode flag
	unsigned char	can_block_mode;
	cyg_flag_t		*pcan_block_flag;
};


// List Class with node type specified to Cyg_CANMSG_NODE
class Cyg_CANMSG_LIST : public Cyg_CList_T<Cyg_CANMSG_NODE>
{

public:
	// constructor for the CAN Msg List
	Cyg_CANMSG_LIST()
	{
	};

	// destructor for the CAN Msg List
	~Cyg_CANMSG_LIST(){ };

	// member function for getting the highest priority node out from the list
	Cyg_CANMSG_NODE* get_highest_can_msg_node(void);

	// member function for getting the node with the specified CAN ID from the list 
	Cyg_CANMSG_NODE* get_can_msg_node(cyg_uint16 std_id, cyg_uint16 ext_id);

};


class Cyg_RECV_FLAG_NODE : public Cyg_DNode_T<Cyg_RECV_FLAG_NODE>
{

public:
	Cyg_RECV_FLAG_NODE()
	{
		std_id = 0;
		ext_id = 0;
	};

	~Cyg_RECV_FLAG_NODE(){ };

	// variable for storing standard CAN ID
	unsigned int	std_id;
	
	// variable for storing extended CAN ID
	unsigned int	ext_id;

	// can block mode flag
	cyg_flag_t		*pcan_block_flag;
};


// List Class with node type specified to Cyg_CANMSG_NODE
class Cyg_RECV_FLAG_LIST : public Cyg_CList_T<Cyg_RECV_FLAG_NODE>
{

public:
	// constructor for the CAN Msg List
	Cyg_RECV_FLAG_LIST()
	{
	};

	// destructor for the CAN Msg List
	~Cyg_RECV_FLAG_LIST(){ };
};

/*
class hqclass
{
public:
	hqclass(){};
	~hqclass(){};
	unsigned char a;
	unsigned char b;
	void hqfun1(void){ diag_printf("Call hqfun1()! a = 0x%02x \n", a);};
	void hqfun2(void){ diag_printf("Call hqfun2()! b = 0x%02x \n", b);};
	void set_a_b(unsigned char m_a, unsigned char m_b){ a=m_a; b=m_b; };
};
*/

extern "C" void *malloc( size_t size );
extern "C" void free( void *ptr );
extern "C" cyg_uint8 node_add_recv(CANMsgStr can_str_msg);
extern "C" cyg_uint8 node_add_send(CANMsgStr can_str_msg);
extern "C" cyg_uint8 node_get_hiprio_can_msg(CANMsgStr *pcan_str_msg, cyg_uint8 op_mode1, cyg_uint8 op_mode2);
extern "C" cyg_uint8 node_get_can_head(CANMsgStr *pcan_str_msg, cyg_uint8 mode);
extern "C" cyg_uint8 node_get_msg(CANMsgStr *pcan_str_msg, cyg_uint8 mode);

/*
extern "C" hqclass* get_hqclass(void);
extern "C" void call_hqfun1(hqclass* m_obj);
extern "C" void call_hqfun2(hqclass* m_obj);
extern "C" void set_ab(hqclass* m_obj, unsigned char m_a, unsigned char m_b);
*/

#else

/*
typedef struct hqclass{
	unsigned char a;
	unsigned char b;
}hqclass;
*/

cyg_uint8 node_add_recv(CANMsgStr can_str_msg);
cyg_uint8 node_add_send(CANMsgStr can_str_msg);
cyg_uint8 node_get_hiprio_can_msg(CANMsgStr *pcan_str_msg, cyg_uint8 op_mode1, cyg_uint8 op_mode2);
cyg_uint8 node_get_can_head(CANMsgStr *pcan_str_msg, cyg_uint8 mode);
cyg_uint8 node_get_msg(CANMsgStr *pcan_str_msg, cyg_uint8 mode);

/*
hqclass* get_hqclass(void);
void call_hqfun1(hqclass* m_obj);
void call_hqfun2(hqclass* m_obj);
void set_ab(hqclass* m_obj, unsigned char m_a, unsigned char m_b);
*/

#endif


#endif // CAN_NODE_HXX
