#ifndef DEF_H
#define DEF_H

#define PLD_ERROR	0x1
#define PLD_CONOK	0x0
#define PLD_BUSY	0x04	// busy bit mask

#define PrintDEBUG	0x0


#define MODE_REMOVE		1
#define MODE_NOREMOVE	2

#define MODE_SEND	1
#define MODE_RECV	2


#define HA_BASE 0x80000000

#define EMPT_FLAG	0
#define FILL_FLAG	1


#define CAN_RX_IRQ		1
#define CAN_TX_IRQ		2
#define CAN_NONE_IRQ	3



// Error code definition for Soft CAN Controller

// generic error code
#define CAN_ERROR		0
#define CAN_NOERROR		1

// for receiving message
#define EMPTY		CAN_ERROR
#define NOTEMPTY	CAN_NOERROR

// for allocating buffer
#define BUF_ERR		CAN_ERROR
#define BUF_NOERR	CAN_NOERROR

// CAN controller config Error Flag
#define CAN_CONF_ERR	CAN_ERROR
#define CAN_CONF_NOERR	CAN_NOERROR


// operation mode
#define CAN_BLOCK	1
#define CAN_NOBLOCK	0


// CAN Configuration definitions
#define CAN_SPEED		1
#define CAN_MASK_FILTER	2

// Speed
#define CAN_1M		1
#define CAN_500K	2
#define CAN_250K	3
#define CAN_125K	4
#define CAN_50K		5



#endif
