#ifndef CYGONCE_HAL_DIAG_H
#define CYGONCE_HAL_DIAG_H

//=============================================================================
//
//      hal_diag.h
//
//      HAL Support for Kernel Diagnostic Routines
//
//=============================================================================

//#####DESCRIPTIONBEGIN####
//
// Author(s):    Qiang Huang
// Contributors: None
// Date:         2003-01-22
// Purpose:      HAL Support for Kernel Diagnostic Routines
// Description:  Diagnostic routines for use during kernel development.
// Usage:        #include <cyg/hal/hal_diag.h>
//
//####DESCRIPTIONEND####
//
//=============================================================================

#include <pkgconf/hal.h>

#include <cyg/infra/cyg_type.h>
#include <cyg/hal/hal_if.h>

//-----------------------------------------------------------------------------

#include <cyg/hal/hal_if.h>

#define HAL_DIAG_INIT()          hal_if_diag_init()
#define HAL_DIAG_WRITE_CHAR(_c_) hal_if_diag_write_char(_c_)
#define HAL_DIAG_READ_CHAR(_c_)  hal_if_diag_read_char(&_c_)

// Not the best place for this, but ...
extern void hal_delay_us(cyg_int32 usecs);

#define HAL_DELAY_US(n)          hal_delay_us(n);

#endif // CYGONCE_HAL_DIAG_H
//-----------------------------------------------------------------------------
// end of hal_diag.h
